export class Main extends Indicator {

    constructor() {
        super();

        this.setProperty(Property.SeparateWindow, true);

        this.addLevel(0);

        this.addInput("BullsPeriod", InputType.int, 13);
        this.addInput("PriceType", InputType.PriceType, PriceType.Bid);

        this.buffers = {
            BullsBuffer : this.addBuffer()
        };

        this.arr = {
            TempBuffer : [],
        };
    }

    onInit() {
        let {BullsPeriod} = this.getInputs();

        this.buffers.BullsBuffer
            .setShape(Shape.Histogram)
            .setColor(Color.Silver)
            .setLabel("Bulls(" + BullsPeriod + ")")
            .setShortName("Bulls(" + BullsPeriod + ")")
        ;
    }

    async onUpdate() {
        const  {BullsPeriod, PriceType} = this.getInputs(),
            {TempBuffer} = this.arr,
            {BullsBuffer} = this.buffers,
            {High, Close} = await Bar.load([Bar.Mode.High,Bar.Mode.Close], PriceType),
            barSize = High.length;

        let i, countedBars = Bar.counted(), limit, list;

        if (barSize <= BullsPeriod) {
            return(0);
        }
        limit = barSize - countedBars;
        if (countedBars > 0) {
            limit++;
        }
        list = await Indicators.MA(null, 0, BullsPeriod, 0, Averaging.Exponential, AppliedPrice.Close, PriceType);
        for (i = 0; i < limit; i++) {
            TempBuffer[i] = list[i];
        }
        i = barSize - countedBars - 1;
        while (i >= 0) {
            BullsBuffer.set(i,  (High[i] - TempBuffer[i]));
            i--;
        }
    }
}
